// C Source File
// Created 9/25/2004; 4:55:37 PM

// Delete or comment out the items you do not need.
#define COMMENT_STRING         "Place your comment here."
#define COMMENT_PROGRAM_NAME   "Place your program name here."
#define COMMENT_VERSION_STRING "Place your version string here."
#define COMMENT_VERSION_NUMBER 0,0,0,0 /* major, minor, revision, subrevision */

#include <tigcclib.h>
#include "extgraph.h"

#include "UserTextWindow.h"
#include "UTW_Example.h"


unsigned char* CurrentPlane0  = 0;
unsigned char* CurrentPlane1  = 0;
unsigned char* PreviousPlane0 = 0;
unsigned char* PreviousPlane1 = 0;

unsigned char* Plane0 = 0;
unsigned char* Plane1 = 0;
unsigned char* Plane2 = 0;
unsigned char* Plane3 = 0;

void* DoubleBuffer = 0;
INT_HANDLER saveInt1;

// Main Function
void _main(void)
{
	char tempStr[32];
	char str1[] = "Fast scrollable text windows with word wrapping example by David Randall.\n\nNow is the time for all good men to come to the aid of their country.\n\nThe quick brown fox jumped over the lazy dog.\n\n";
	char* font_4x6;
	long delayCounter;
	static int i = 0; 
	
	int scrollDir2 = 1;
	int scrollDir3 = 1;
	int scrollDir5 = 1;
	
	UserTextWindowType myWindow1;
	UserTextWindowType myWindow2;
	UserTextWindowType myWindow3;
	UserTextWindowType myWindow4;
	UserTextWindowType myWindow5;
	UserTextWindowType myWindow6;
	
	if (!GrayScaleOn())
		return;
		
	font_4x6 = (char*)LoadFile((char*)"font1");
	if (!font_4x6) 
	{
		while(1)
		{
			if (_keytest (RR_ESC))
				break;
			PortSet (CurrentPlane0, 239, 127);
			DrawStr(5,5,"File not found: font1", A_NORMAL);
			PortSet (CurrentPlane1, 239, 127);
			DrawStr(5,5,"File not found: font1", A_NORMAL);
			SwapPlaneBuffers();
			
			for (delayCounter = 0; delayCounter < 20000; delayCounter++); // 20000 is a good number
		}
		
		GrayScaleOff();
		return;
	}
	
	UTW_Create( 80,  2,112, 30,1,1,1,1,COLOR_WHITE,COLOR_BLACK,font_4x6,4,6,10,&CurrentPlane0,&CurrentPlane1,&myWindow1);
	UTW_Create(145, 50, 75, 77,3,1,1,1,COLOR_WHITE,COLOR_DARKGRAY,font_4x6,4,6,20,&CurrentPlane0,&CurrentPlane1,&myWindow2);
	UTW_Create(110, 40, 40, 72,2,1,1,1,COLOR_BLACK,COLOR_LIGHTGRAY,font_4x6,4,6,30,&CurrentPlane0,&CurrentPlane1,&myWindow3);
	UTW_Create(  2,  2, 70,124,1,1,1,1,COLOR_LIGHTGRAY,COLOR_BLACK,font_4x6,4,6,10,&CurrentPlane0,&CurrentPlane1,&myWindow4);
	UTW_Create( 13, 50, 40, 70,3,1,1,1,COLOR_DARKGRAY,COLOR_WHITE,font_4x6,4,6,20,&CurrentPlane0,&CurrentPlane1,&myWindow5);
	UTW_Create( 50, 65, 70, 30,2,1,1,1,COLOR_WHITE,COLOR_DARKGRAY,font_4x6,4,6,30,&CurrentPlane0,&CurrentPlane1,&myWindow6);

	UTW_Print(&myWindow2, str1);
	UTW_Print(&myWindow3, str1);
	UTW_Print(&myWindow4, str1);
	UTW_Print(&myWindow5, str1);

	while(1)
	{
		if (_keytest (RR_ESC))
			break;

		UTW_ClearHome(&myWindow1);
		UTW_Print(&myWindow1, "Hello world!");
		
		sprintf(tempStr, "Count = %u", i++);
		UTW_Print(&myWindow6, tempStr);
		
		if (UTW_Scroll(&myWindow2, scrollDir2))
			scrollDir2 = scrollDir2 * -1;

		if (UTW_Scroll(&myWindow3, scrollDir3))
			scrollDir3 = scrollDir3 * -1;

		UTW_Scroll(&myWindow5, -1);		
				
		UTW_Draw(&myWindow1);
		UTW_Draw(&myWindow2);
		UTW_Draw(&myWindow3);
		UTW_Draw(&myWindow4);
		UTW_Draw(&myWindow5);
		UTW_Draw(&myWindow6);
				
		SwapPlaneBuffers();
		
		for (delayCounter = 0; delayCounter < 20000; delayCounter++); // 20000 is a good number

	}

	UTW_Close(&myWindow1);
	UTW_Close(&myWindow2);
	UTW_Close(&myWindow3);
	UTW_Close(&myWindow4);
	UTW_Close(&myWindow5);
	UTW_Close(&myWindow6);
	
	GrayScaleOff();
}


void SwapPlaneBuffers(void)
{
	if (DoubleBuffer)
	{ 
		// sync prior to toggling the double plane buffers to minimize flickering
		GrayDBufToggleSync();
		
		// toggle the double plane buffers 
		if (CurrentPlane0 == Plane0)
		{
			CurrentPlane0  = Plane2;
			CurrentPlane1  = Plane3;
			PreviousPlane0 = Plane0;
			PreviousPlane1 = Plane1;
		}
		else
		{
			CurrentPlane0  = Plane0;
			CurrentPlane1  = Plane1;
			PreviousPlane0 = Plane2;
			PreviousPlane1 = Plane3;			
		}
	}
}

short GrayScaleOn()
{
	DoubleBuffer = 0;
	saveInt1 = GetIntVec (AUTO_INT_1);
		
	// This saves the interrupt vector 1
	SetIntVec (AUTO_INT_1, DUMMY_HANDLER);   // redirect auto-int 1 to "nothing"
	
	if (GrayOn ()) 
	{
		DoubleBuffer = malloc(GRAYDBUFFER_SIZE);
	
		if (!DoubleBuffer)
		{ 
			GrayOff();
			return 0;
		}
		
		GrayDBufInit(DoubleBuffer);
		GrayDBufToggleSync();

		Plane0 = GrayGetPlane(LIGHT_PLANE);
		Plane1 = GrayGetPlane(DARK_PLANE);
		Plane2 = (unsigned char*)GrayDBufGetPlane(1,LIGHT_PLANE);
		Plane3 = (unsigned char*)GrayDBufGetPlane(1,DARK_PLANE);	

		CurrentPlane0  = Plane0;
		CurrentPlane1  = Plane1;
		PreviousPlane0 = Plane2;
		PreviousPlane1 = Plane3;

		GrayClearScreen2B((void*) Plane0,(void*) Plane1);	
		GrayClearScreen2B((void*) Plane2,(void*) Plane3);	
			
		return 1;
	}
	
	return 0;
}

void GrayScaleOff()
{
	GrayOff();
	
	if (DoubleBuffer)
		free(DoubleBuffer);
	
	SetIntVec (AUTO_INT_1, saveInt1);
}

void* LoadFile(char* filename)
{
	SYM_ENTRY* pSymEntry = DerefSym (SymFind (SYMSTR (filename)));
	
	if (pSymEntry)
	{
		if (!HeapGetLock(pSymEntry->handle))
			HeapLock(pSymEntry->handle);
			
		return (void*)(HeapDeref (pSymEntry->handle) + 2); 
	}
	
	return 0;
}
